const wx = require('../../weidogs');

let app = getApp(), $ = require('../../utils/util.js'), groupByAPI = require('../../api/groupBuyAPI.js');
var templateMethods = require('../../utils/template_methods.js');
Page(Object.assign({}, templateMethods, {
  data: {},
  onLoad: function (options) {
    this.setMenu(this);
    this.setData({ tempE: options });
  },
  onShow() {
    let that = this;
    let options = that.data.tempE;
    app.GetUserInfo(function () {
      app.globalData.getTop();
      if (options['index'] == 1) {
        that.orderList();
      } else {
        that.productList();
      }
    });
  },
  cleanData: function () {
    let that = this;
    for (let attr in that.data) {
      if (that.data.hasOwnProperty(attr) && attr != '__webviewId__') {
        that.data[attr] = undefined;
      }
    }
    that.setData(that.data);
  },
  productList: function () {
    let that = this;
    that.cleanData();
    that.setData({
      tabIndex: 0,
      page: 1,
      hasMore: 1,
      productList: []
    });
    that.loadProduct();
  },
  loadProduct: function () {
    let that = this;
    let api = groupByAPI.getProductList;
    api.data = Object.assign(api.data, {
      openid: app.globalData.UserInfo.WeiXinOpenId,
      page: that.data.page
    });
    api = Object.assign(api, {
      success: function (resp) {
        console.log('商品列表', resp);
        let productList = that.data.productList;
        productList = productList.concat(resp.data);
        let hasMore = resp.data.length != 0;
        that.setData({
          productList: productList,
          hasMore: hasMore,
          page: that.data.page + 1
        });
      },
      error: function () {
        my.confirm({
          title: 'Error',
          content: '加载失败',
          showCancel: 0
        });
      }
    });
    wx.request(api);
  },
  scrollbottom: function () {
    let that = this;
    if (that.data.tabIndex == 0 && that.data.hasMore) {
      console.log('加载下一页商品');
      that.loadProduct();
    } else if (that.data.tabIndex == 1 && that.data.hasMore) {
      console.log('加载下一页商品');
      that.loadOrder();
    }
  },
  goToDetail: function (e) {
    let id = e.currentTarget.dataset.id;
    let index = e.currentTarget.dataset.index;
    console.log('按钮的点击事件', e);
    console.log('点击的商品id是', id);
    my.navigateTo({ url: '/pages/groupbuydetail/groupbuydetail?id=' + id + '&index=' + index });
  },
  orderList: function () {
    let that = this;
    that.cleanData();
    that.setData({
      tabIndex: 1,
      page: 1,
      hasMore: 1,
      orderList: []
    });
    that.loadOrder();
  },
  loadOrder: function () {
    let that = this;
    let api = groupByAPI.getOrderList;
    console.log(groupByAPI.getOrderList);
    api.data = Object.assign(api.data, {
      openid: app.globalData.UserInfo.WeiXinOpenId,
      page: that.data.page
    });
    api = Object.assign(api, {
      success: function (resp) {
        console.log('订单列表', resp);
        let orderList = that.data.orderList;
        orderList = orderList.concat(resp.data);
        let hasMore = resp.data.length != 0;
        that.setData({
          orderList: orderList,
          hasMore: hasMore,
          page: that.data.page + 1
        });
      },
      error: function () {
        my.confirm({
          title: 'Error',
          content: '加载失败',
          showCancel: 0
        });
      }
    });
    wx.request(api);
  },
  receive: function (e) {
    let that = this;
    my.confirm({
      title: '确认',
      content: '确定要确认收货吗\uFF1F',
      success: function (confirm) {
        if (confirm.confirm) {
          let orderId = e.currentTarget.dataset.orderId;
          let orderIndex = e.currentTarget.dataset.orderIndex;
          let api = groupByAPI.receive;
          api.data.orderId = orderId;
          api.success = function (resp) {
            let data = resp.data;
            if (data.is_receive == 1) {
              that.data.orderList[orderIndex]['status'][0] = 3;
              that.data.orderList[orderIndex]['status'][1] = '已收货';
              that.setData({ orderList: that.data.orderList });
            }
          };
          wx.request(api);
        }
      }
    });
  }
}));