const wx = require('../../weidogs');
/* converted by appconverter    	      		  
   on Monday, August 27th, 2018, 2:55:03 PM
*/
var app = getApp();
let myTools = require('../../utils/myTools');
let templateMethods = require('../../utils/template_methods.js');
let tc_common = require('../../utils/tc_common');
let tcApi = require('../../api/tcApi');
Page(Object.assign({}, {
    data: {
        is_top: true,
        latitude: null,
        longitude: null,
        address: null,
        img: [],
        content: '',
        numIndex : 0
    },
    onLoad: function (option) {
        let t = this, ts = t.data;
        this.setMenu(this);
        app.globalData.getTop(t);
        t.setData({ cate_id: option.id });
        t.loadSetting();
        t.loadCate(option.id);
    },
    onIsTopChange: function (e) {
        let t = this, td = t.data;
        this.setData({
            is_top: e.detail.value ? false : true,
            top_time: td.setting.top_setting[0]['top_time'],
            top_money: td.setting.top_setting[0]['top_money']
        });
    },
    bindInputContent(e) {
        let t = this, val = e.detail.value;
        t.setData({ content: val });
    },
    bindSelectAddress() {
        let t = this, td = t.data;
        my.chooseLocation({
            success: function (res) {
                console.log(res);
                var latitude = res.latitude;
                var longitude = res.longitude;
                var address = res.address;
                t.setData({
                    latitude: latitude,
                    longitude: longitude,
                    address: address
                });
            },
            fail(e) {
                console.log(e);
                if (e.errMsg == 'chooseLocation:fail auth deny') {
                    my.confirm({
                        title: '错误',
                        content: '请授权位置信息',
                        success(s) {
                            if (s.confirm) {
                                my.openSetting();
                            }
                        }
                    });
                }
            }
        });
    },
    bindSelectTopTime(e) {
        let t = this, td = t.data, idx = e.detail.value;
        
        t.setData({
            top_time: td.setting.top_setting[idx]['top_time'],
            top_money: td.setting.top_setting[idx]['top_money']
        });
    },
    bindSelectImg(e) {
        let t = this, api = tcApi.uploadImg;
        if (t.data.img.length >= 3) {
            wx.showToast({ title: '最多3张图片' });
            return false;
        }
        wx.chooseImage({
            count: 3,
            sizeType: ['compressed'],
            sourceType: [
                'album',
                'camera'
            ],
            success: function (res) {
                console.log(res);
                var imgSrc = res.tempFilePaths;
                for (var i = 0; i < imgSrc.length; i++) {
                    wx.uploadFile({
                        url: api.url,
                        filePath: imgSrc[i],
                        name: 'img',
                        method: 'post',
                        success: function (resp) {
                            let r = JSON.parse(resp),
                             url = r.data;
                            console.log('ssfdmfj',url);
                            let imgList = t.data.img;
                            // for (let i = 0; i < imgList.length; i++) {
                            //     if (imgList[i] == url) {
                            //         wx.showToast({ title: '图片已存在' });
                            //         return false;
                            //     }
                            // }
                            imgList.push(url);
                            t.setData({ img: imgList });
                        },
                        fail: function () {
                            wx.showToast({ title: '图片上传失败' });
                        }
                    });
                }
            }
        });
    },
    bindDeleteImg(e) {
      let t = this;
        my.confirm({
            title: '温馨提示',
            content: '确认要删除这张图片吗',
            success: (result) => {
                if(result.confirm){
                    var idx = e.currentTarget.dataset.index;
                    let imgList = t.data.img;
                    imgList.splice(idx, 1);
                    t.setData({ img: imgList });
                }
            },
        });
    },
    bindPreviewImg(e) {
        let t = this, idx = e.currentTarget.dataset.index;
        let imgList = t.data.img;
        my.previewImage({ urls: [imgList[idx]] });
    },
    bindPublish(e) {
        if(this.data.is_top){
            var is_top = 0;
        }else{
            var is_top = 1
        }
        let t = this, td = t.data;
        if (td.content == '') {
            wx.showToast({
                title: '请输入内容',
                mask: 1
            });
            return false;
        }
        if (!td.address || !td.latitude || !td.longitude) {
            wx.showToast({
                title: '请重新选择地址',
                mask: 1
            });
            return false;
        }
        let api = tcApi.submitMsg;
        console.log(api);
        wx.request({
            url: api.url,
            method: api.method,
            data: {
                wid: api.data.wid,
                openid: app.globalData.UserInfo.WeiXinOpenId,
                cate_id: td.cate_id,
                content: td.content,
                img: td.img,
                lat: td.latitude,
                lng: td.longitude,
                address: td.address,
                is_top: is_top,
                top_time: td.top_time
            },
            success(resp) {
                 console.log('支付回调参数',resp)
                if(resp.data.status == 'success'){
                    
                        if(resp.data.data.pay_params.alipay_trade_create_response.code == '10000'){
                                my.tradePay({
                                    tradeNO: resp.data.data.pay_params.alipay_trade_create_response.trade_no, //完整的支付参数拼接成的字符串，从服务端获取
                                    success: function (n) {
                                    switch(n.resultCode){
                                        case '9000' :
                                             t.doRedirectToMyPublish();
                                        break;
                                        case '4000':
                                            my.showToast({
                                            type: 'fail',
                                            content: '订单支付失败',
                                            });
                                        break;
                                        case '6001':
                                            my.showToast({
                                            type: 'fail',
                                            content: '您取消支付',
                                            });                    
                                        break;
                                        case '6002' :
                                            my.showToast({
                                            type: 'fail',
                                            content: '网络连接出错',
                                            });
                                        break;                    
                                    }
                                    },
                                    fail: function (n) {
                                        t.doRedirectToMyPublish();              
                                    }
                                });
                            }else{
                                t.doRedirectToMyPublish();
                            }
                }else{
                            my.showToast({
                            type: 'fail',
                            content: '网络连接出错了',
                            });
                }
               
            }
        });
    },
    doPayment(payParams) {
        let t = this;
        payParams.success = function () {
            my.confirm({
                title: '成功',
                content: '支付成功',
                showCancel: 0,
                success() {
                    t.doRedirectToMyPublish();
                }
            });
        };
        payParams.fail = function () {
            my.confirm({
                title: '失败',
                content: '支付未完成\uFF0C请稍后重新支付',
                showCancel: 0,
                success() {
                    t.doRedirectToMyPublish();
                }
            });
        };
        my.tradePay(payParams);
    },
    doRedirectToMyPublish() {
        my.navigateTo({ url: '/pages/tc_lists/tc_lists?type=my&show_pay_btn=1' });
    }
}, templateMethods, tc_common));