const wx = require('../../weidogs');
var app = getApp();
let zhctApi = require('../../api/zhctAPI');
let myTools = require('../../utils/myTools');
let templateMethods = require("../../utils/template_methods.js");
Page(Object.assign({}, {
  data: {
    orderList: [],
    orderStatus: -1,//全部订单，0未确认，1已确认，2已完成
    page: 0,
    hasMore: true,
    this_group_val: -1,
    show_payMethod: true,
  },
  onLoad() {
    let t = this, td = t.data;
    this.setMenu(this);
    app.globalData.getTop();
    // 获取配色设置
    let main_color = my.getStorageSync({ key: 'zhct_main_color' });
    if (main_color.data != undefined) {
      my.setStorageSync({
        key: 'main_color',
        data: '#fe5848'
      });
    }
    this.setData({
      main_color: main_color,
      editData_h: app.globalData.editData_h
    });
    let api = zhctApi.getInfo;
    wx.request({
      url: api.url,
      data: {
        wid: api.data.wid
      },
      method: 'POST',
      success(resp) {

        var rData = resp.data;
        console.log('vbnvb', rData)
        var pay_wx, pay_ye;
        if (rData.data.pay_wx == undefined || rData.data.pay_wx == null || rData.data.pay_wx == '') {
          pay_wx = 99999;
        } else {
          pay_wx = rData.data.pay_wx;
        }
        if (rData.data.pay_ye == undefined || rData.data.pay_ye == null || rData.data.pay_ye == '') {
          pay_ye = 99999;
        } else {
          pay_ye = rData.data.pay_ye;
        }
        if (pay_wx === 99999 && pay_ye == 99999) {
          my.showToast({
            content: '商家未设置支付方式,暂不可进行支付',
            type: 'fail',
            duration: 3000
          });
        }
        t.setData({
          pay_wx: pay_wx,
          pay_ye: pay_ye
        });
      },

    });
    console.log(t.data)
    console.log(zhctApi.orderPay);
  },
  onShow: function () {
    // 加载商品
    this.loadOrder(true);
  },
  loadOrder(reload = false) {
    let t = this, td = t.data;
    if (reload) {
      t.setData({
        page: 0,
        hasMore: true,
      });
    }
    let api = zhctApi.getOrderList;
    if (td.isLoading || !td.hasMore) {
      return false;
    }
    t.setData({ isLoading: true });
    //   my.showLoading({
    //   content: '加载中...',
    //   delay: 1000,
    // });
    wx.request({
      url: api.url,
      method: api.method,
      data: {
        wid: api.data.wid,
        openid: app.globalData.UserInfo.WeiXinOpenId,
        page: td.page,
        orderStatus: td.orderStatus,
      }, success(res) {
        var that = this;
        if (res.data.data.length == 0) {
          my.showToast({
            content: '暂无您的订单信息',
            duration: 3000
          });
          that.setData({
            length: 0
          })
          return;
        }
        console.log('数据列表', res)
        let r = res.data, rd = r.data;
        if (r.status == 'success') {
          if (reload) {
            // 清空当前的数据
            t.setData({
              orderList: [],
              page: 0,
              hasMore: true,
              length: 1
            });
          }
          // 处理新数据
          let hasMore = rd.length != 0;
          let orderList2 = [...td.orderList, ...rd];
          let page = td.page + 1;
          t.setData({
            hasMore: hasMore,
            page: page,
            orderList: orderList2,
            length: 1
          });
        } else {
          my.showToast({
            content: r.msg,
            type: 'fail',
            duration: 3000
          });
        }
      }, fail(r) {
        my.showToast({
          content: r.msg,
          type: 'fail',
          duration: 3000
        });
      }, complete() {
        t.setData({ isLoading: false });
        my.hideLoading();
        my.stopPullDownRefresh();
      }

    });

  },
  //订单状态切换
  select_status_show: function (e) {
    let val = e.currentTarget.dataset.val;
    this.setData({
      orderStatus: val,
      this_group_val: val
    });
    this.loadOrder(true);
  },
  bind_order_cancel(e) {
    let t = this, td = t.data, ds = e.currentTarget.dataset;
    let cancelFunc = function () {
      let orderId = ds.id;
      let api = zhctApi.orderCancel;
      wx.request({
        url: api.url,
        method: api.method,
        data: {
          wid: api.data.wid,
          openid: app.globalData.UserInfo.WeiXinOpenId,
          orderId: orderId,
        }, success(resp) {
          let r = resp.data, rd = r.data;
          if (r.status == 'success') {
            t.loadOrder(true);
          } else {
            my.showToast({
              content: r.msg,
              type: 'fail',
              duration: 3000
            });
          }
        }, fail() {
          my.showToast({
            content: '未知错误',
            type: 'fail',
            duration: 3000
          });
        }
      });
    };

    my.confirm({
      title: '提示',
      content: '确认取消订单吗？',
      success(res) {
        if (res.confirm) {
          cancelFunc();
        }
      }
    });
  },
  bind_order_ok(e) {
    let t = this, td = t.data, ds = e.currentTarget.dataset;
    let orderId = ds.id;
    let api = zhctApi.orderOK;
    // my.showLoading({content: '加载中'});
    wx.request({
      url: api.url,
      method: api.method,
      data: {
        wid: api.data.wid,
        openid: app.globalData.UserInfo.WeiXinOpenId,
        orderId: orderId,
      }, success(resp) {
        let r = resp.data, rd = r.data;
        if (r.status == 'success') {
          t.loadOrder(true);
        } else {
          my.showToast({
            content: r.msg,
            type: 'fail',
            duration: 3000,
          });
        }
      }, fail() {
        my.showToast({
          content: '网络错误',
          duration: 3000,
        });
      }, complete() {
        // my.hideLoading();
      }
    });
  },
  bind_order_pay(e) {
    let t = this, td = t.data, ds = e.currentTarget.dataset;
    console.log(ds);
    let formId = e.detail.formId;
    let orderId = ds.id;
    let api = zhctApi.orderPay;
    console.log(zhctApi.orderPay);
    // my.showLoading({content: '加载中'});
    wx.request({
      url: api.url,
      method: api.method,
      data: {
        wid: api.data.wid,
        openid: app.globalData.UserInfo.WeiXinOpenId,
        orderId: orderId,
        formId: formId
      },
      success(resp) {
        console.log('支付成功回调', resp)
        if (resp.data.data.alipay_trade_create_response.code == '10000') {
          my.tradePay({
            tradeNO: resp.data.data.alipay_trade_create_response.trade_no, //完整的支付参数拼接成的字符串，从服务端获取
            success: function (n) {
              switch (n.resultCode) {
                case '9000':
                  my.redirectTo({ url: '/pages/zhct_orderlist/zhct_orderlist' });
                  break;
                case '4000':
                  my.showToast({
                    type: 'fail',
                    content: '订单支付失败',
                    success() {
                      my.redirectTo({ url: '/pages/zhct_orderlist/zhct_orderlist' });
                    }
                  });
                  break;
                case '6001':
                  my.showToast({
                    type: 'fail',
                    content: '您取消支付',
                    success() {
                      my.redirectTo({ url: '/pages/zhct_orderlist/zhct_orderlist' });
                    }
                  });
                  break;
                case '6002':
                  my.showToast({
                    type: 'fail',
                    content: '网络连接出错',
                    success() {
                      my.redirectTo({ url: '/pages/zhct_orderlist/zhct_orderlist' });
                    }
                  });

                  break;
              }
            },
            fail: function (n) {
              my.showToast({
                type: 'fail',
                content: '订单支付失败',
              });
            }
          });
        } else {
          my.showToast({
            type: 'fail',
            content: resp.data.data.alipay_trade_create_response.sub_msg
          })
        }
      }, fail() {
        my.showToast({
          type: 'fail',
          content: '网络错误',
          duration: 3000,
        });
      }, complete() {
        // my.hideLoading();
      }
    });
  },

  //订单详情
  user_orderinfo_bind: function (e) {
    let t = this, td = t.data, ds = e.currentTarget.dataset;
    let orderId = ds.id;
    console.log(orderId);
    my.navigateTo({
      url: '/pages/zhct_orderinfo/zhct_orderinfo?orderId=' + orderId
    });
  },
  //下拉刷新
  onPullDownRefresh: function () {
    this.loadOrder(true);
  },
  // 显示支付方式
  show_payMethod: function (e) {
    let t = this;
    let ds = e.currentTarget.dataset;
    t.setData({
      orderid_h: ds.id,
      show_payMethod: false
    })
    console.log(t.data);
  },
  hide_payMethod: function () {
    let t = this;
    t.setData({
      show_payMethod: true
    })
  },
  // 余额支付
  payMethod_Submit: function (e) {
    let t = this, td = t.data;
    // 收集提交订单所需的参数
    let orderid_h = e.currentTarget.dataset.id;
    console.log(orderid_h);
    my.navigateTo({
      url: "/pages/payment/payment?type=zhct&orderid=" + orderid_h
    });
  },


  //评价
  order_go_comment_bind: function (e) {
    var ord_id = e.currentTarget.dataset.id;
    console.log(ord_id);
    my.navigateTo({
      url: '/pages/zhct_order_comment/zhct_order_comment?orderId=' + ord_id
    });
  },
  onReachBottom() {
    this.loadOrder();
  }
}, templateMethods));