const wx = require('../weidogs');
/* converted by appconverter    	      		  
   on Monday, August 27th, 2018, 2:55:02 PM
*/
let app = getApp();
let moreshopApi = require('../api/moreshopApi');
let myTools = require('../utils/myTools');
let WxParse = require('../wxParse/wxParse.js');
module.exports = {
    shop_list: function (type, latitude, longitude, keywords = null) {
        let t = this;
        let api = moreshopApi.getShopList;
        wx.showLoading({
            title: 'loading',
            mask: 1
        });
        wx.request({
            url: api.url,
            data: {
                wid: api.data.wid,
                type: type,
                latitude: latitude,
                longitude: longitude,
                keywords: keywords
            },
            method: 'POST',
            success: function (e) {
                if (e.data.status == 'error') {
                    my.confirm({
                        title: '提示',
                        content: e.data.msg,
                        showCancel: 0,
                        success: function () {
                        }
                    });
                } else {
                    console.log('cccdfgrt',e.data.data);
                    t.setData({ shopList: e.data.data });
                }
            },
            complete() {
                my.hideLoading();
            }
        });
    },
    paySellerIn: function (openid) {
        let t = this;
        let api = moreshopApi.paySellerIn;
        wx.request({
            url: api.url,
            data: {
                wid: api.data.wid,
                openid: openid
            },
            method: 'POST',
            success: function (resp) {
                console.log('后台验证签名后获得的数据', resp);
                 if(resp.data.payObj.alipay_trade_create_response.code == '10000'){
                                my.tradePay({
                                    tradeNO: resp.data.payObj.alipay_trade_create_response.trade_no, //完整的支付参数拼接成的字符串，从服务端获取
                                    success: function (n) {
                                    switch(n.resultCode){
                                        case '9000' :
                                            my.showToast({
                                            type: 'success',
                                            content: '订单支付成功',
                                            });
                                        break;
                                        case '4000':
                                            my.showToast({
                                            type: 'fail',
                                            content: '订单支付失败',
                                            });
                                        break;
                                        case '6001':
                                            my.showToast({
                                            type: 'fail',
                                            content: '您取消支付',
                                            });                    
                                        break;
                                        case '6002' :
                                            my.showToast({
                                            type: 'fail',
                                            content: '网络连接出错',                                         
                                            });

                                        break;                    
                                    }
                                    },
                                    fail: function (n) {
                                        my.showToast({
                                        type: 'fail',
                                        content: '订单支付失败',
                                        });                 
                                    }
                                });
                            }else{
                                my.showToast({
                                    type:'fail',
                                    content:resp.data.payObj.alipay_trade_create_response.sub_msg
                                })
                            }
            }
        });
    },
    getShopInfo: function (id) {
        let t = this;
        let api = moreshopApi.getShopInfo;
        wx.showLoading({
            title: 'loading',
            mask: 1
        });
        wx.request({
            url: api.url,
            data: {
                wid: api.data.wid,
                id: id
            },
            method: 'POST',
            success: function (e) {
                console.log(e.data.data);
                t.setData({ shopInfo: e.data.data });
                WxParse.wxParse('info', 'html', e.data.data.shop_intro, t);
                my.setNavigationBar({ title: e.data.data.shop_name });
            },
            complete: function () {
                my.hideLoading();
            }
        });
    },
    loadProduct: function (shopid) {
        let that = this;
        let api = moreshopApi.getGoodsList;
        wx.request({
            url: api.url,
            data: {
                wid: api.data.wid,
                shopid: shopid
            },
            method: 'POST',
            success: function (resp) {
                console.log('商品列表', resp.data.data);
                let productList = resp.data.data;
                that.setData({ productList: productList });
            },
            error: function () {
                my.confirm({
                    title: 'Error',
                    content: '加载失败',
                    showCancel: 0
                });
            }
        });
    }
};